#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <winsock2.h>



SOCKET g_sock;
FILE *g_pFile;

void initialize();
void __cdecl finalize(int signal);

void loop();
void writeLog();


int main()
{
	initialize();
	loop();

	return 0;
}

void initialize()
{
	WSADATA wsaData;
	servent *pServe;
	sockaddr_in self;


	g_pFile = fopen("syslog.txt", "at");
	signal(SIGINT, finalize);

	WSAStartup(MAKEWORD(1, 1), &wsaData);

	pServe = getservbyname("syslog", "udp");

	g_sock = socket(AF_INET, SOCK_DGRAM, 0);

	memset(&self, 0, sizeof(sockaddr_in));
	self.sin_family = AF_INET;
	self.sin_port = pServe->s_port;

	bind(g_sock, (sockaddr *)&self, sizeof(sockaddr_in));
}

void __cdecl finalize(int)
{
	shutdown(g_sock, SD_BOTH);
	closesocket(g_sock);
	WSACleanup();
	fclose(g_pFile);
	exit(0);
}

void loop()
{
	fd_set read_mask, mask;
	timeval timeout;
	int width;

	width = 0;
	FD_ZERO(&mask);
	FD_SET(g_sock, &mask);

	while (true)
	{
		read_mask = mask;
		timeout.tv_sec = 5;
		timeout.tv_usec = 0;

		switch (select(width, &read_mask, NULL, NULL, &timeout))
		{
		case SOCKET_ERROR:
			break;

		case 0:
			break;

		default:
			if (FD_ISSET(g_sock, &read_mask))
				writeLog();

			break;
		}
	}
}

void writeLog()
{
	int packetSize;
	char aBuffer[1024];
	sockaddr_in addrFrom;
	int lenFrom;
	int i, len;
	time_t timeNow;
	tm *pTime;
	char aTime[32];

	packetSize = recvfrom(g_sock, aBuffer, sizeof(aBuffer), 0, (sockaddr *)&addrFrom, &lenFrom);

	aBuffer[sizeof(aBuffer)-1] = '\0';
	if (packetSize < sizeof(aBuffer))
		aBuffer[packetSize] = '\0';

	len = strlen(aBuffer);
	for (i=0; i<len; i++)
		if (iscntrl(aBuffer[i]))
			aBuffer[i] = '.';

	time(&timeNow);
	pTime = localtime(&timeNow);
	sprintf(aTime, "%4d/%2d/%2d %2d:%2d:%2d",
		1900 + pTime->tm_year, 1 + pTime->tm_mon, pTime->tm_mday,
		pTime->tm_hour, pTime->tm_min, pTime->tm_sec);

	fprintf(g_pFile, "%s  %s\n", aTime, aBuffer);
	fflush(g_pFile);
	fprintf(stderr, "%s  %s\n", aTime, aBuffer);
	fflush(stderr);
}
